

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

extern unsigned long long tim();

extern void sched_yield(void);

int main(int args, char *argv[])
{
    unsigned long long cpu_speed, tt, calib;
    double usec;

    (void)tim();        /* Initialize */
    calib = tim();      /* Calibrate function-call CPU cycles */
    printf("Testing CPU Speed (once at start of program)\n");
    (void)tim();
    (void)sleep(1);
    cpu_speed = tim() - calib;
    printf("CPU speed = %llu Hz\n", cpu_speed);
    printf("Cycles to make the two function calls = %llu\n", calib);
    (void)tim();
    usleep(1);
//    sched_yield();
    tt = tim() - calib;
    usec = (double) tt / (double) cpu_speed;
    usec *= 1e6;
    printf("It took %llu cpu cycles or %f microseconds.\n", tt, usec);
    return 0;
}


